사용자는 구조화된 참조를 사용하여 워크시트에서 표와 같은 테이블 시트를 참조할 수 있습니다.
테이블 시트 이름은 표 이름이고 열 캡션은 표 열입니다. 샘플 코드는 다음과 같습니다.
또한 A1/R1C1 참조 스타일을 지원하지만 읽는 것이 어렵습니다.
참조 스타일은 셀 수식, 차트, 조건부 서식에서 사용할 수 있습니다.
사용자는 QUERY 함수를 사용하여 DataManager 표에서 데이터를 가져올 수 있습니다.
QUERY 구문
인수
설명
tableAndRows
(필수) DataManager 테이블 이름과 선택적 행 선택자 또는 필터를 지정합니다.
[columns]
(선택 사항) 반환할 열을 지정합니다. 생략하면 모든 열이 반환됩니다.
[returnObject]
(선택 사항) 각 행을 DataObject로 반환할지 여부를 지정합니다. 기본값은 FALSE입니다.
반환 유형
예시
전체 표
QUERY("table1")
전체 열
QUERY("table1", "column1")
데이터
QUERY("table1#1", "column1")QUERY("customer/abc@gmail.com", "name")
특정 행
QUERY("table1#1")QUERY("customer/abc@gmail.com")
DataObject
QUERY("productTable?Id=1",,TRUE)
행 필터
사용자는 간단한 행 필터를 사용할 수 있습니다.
유형
예시
행 인덱스별
QUERY("table1#1")
행 기본 키별
QUERY("customer/abc@gmail.com")
키-값 필터별
QUERY("order?status=sucess")
여러 열
사용자는 배열을 사용하여 많은 열을 선택할 수 있습니다.
유형
예시
열 배열별
QUERY("order?status=shipping", {"order date", "address", "Cargo weight"})
1차원 참조별
QUERY("order?status=shipping", A1:D1)
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
window.onload = function() {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 1 });
initSpread(spread);
};
function initSpread(spread) {
spread.suspendPaint();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
spread.options.allowDynamicArray = true;
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add product table
var productTable = dataManager.addTable("productTable", {
remote: {
read: {
url: baseApiUrl + "/Product"
}
}
});
//add category table
var categoryTable = dataManager.addTable("categoryTable", {
remote: {
read: {
url: baseApiUrl + "/Category"
}
}
});
//add relation ship
dataManager.addRelationship(productTable, "CategoryId", "category", categoryTable, "Id", "products");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader);
//bind a view to the table sheet
var myView = productTable.addView("myView", [
{ value: "Id", caption: "ID" },
{ value: "category.CategoryName", caption: "Category", width: 120 },
{ value: "ProductName", caption: "Product Name", width: 200 },
{ value: "UnitPrice", caption: "Unit Price", width: 120 },
{ value: "UnitsInStock", caption: "Units In Stock", width: 120 },
{ value: "UnitsOnOrder", caption: "Units On Order", width: 130 },
{ value: "=SUM([@UnitsInStock], [@UnitsOnOrder])", caption: "Total Amount", width: 130 },
{ value: "=[@UnitPrice] * SUM([@UnitsInStock], [@UnitsOnOrder])", caption: "Total Price", width: 120 }
]);
myView.fetch().then(function() {
spread.suspendPaint();
sheet.setDataView(myView);
var sheet1 = spread.getSheet(0);
sheet1.setColumnWidth(0, 170);
sheet1.setColumnWidth(1, 95);
sheet1.setColumnWidth(2, 95);
sheet1.setColumnWidth(3, 120);
sheet1.setColumnWidth(4, 170);
sheet1.setColumnWidth(6, 110);
sheet1.setColumnWidth(7, 170);
sheet1.setValue(0, 0, "Product Count:")
sheet1.setFormula(0, 1, "=COUNTA(TableSheet1[ID])");
sheet1.setValue(0, 3, 'Total Price:')
sheet1.setFormula(0, 4, '=SUM(TableSheet1[Total Price])');
//Category Summary
applyTableStyleForRange(sheet1, 3, 0, 9, 5);
sheet1.setValue(2, 0, "Category Summary:")
sheet1.setArray(3, 0, [
["Category", "Product No", "On Order Cost", "Highest Unit Price", "Highest Price Product"]
]);
sheet1.setFormula(4, 0, '=UNIQUE(TableSheet1[Category])');
sheet1.setFormula(4, 1, '=COUNTIF(TableSheet1[Category], A5#)');
sheet1.setFormula(4, 3, '=MAXIFS(TableSheet1[Unit Price], TableSheet1[Category], A5#)');
for (var i = 5; i <= 12; i++) {
sheet1.setFormula(i - 1, 2, '=SUMPRODUCT((TableSheet1[Category]=A' + i + ')*TableSheet1[Units On Order],TableSheet1[Unit Price])');
sheet1.setFormula(i - 1, 4, '=XLOOKUP(D' + i + ', IF(TableSheet1[Category] = A' + i + ', TableSheet1[Unit Price], -1), TableSheet1[Product Name])');
}
//Out of Stock
sheet1.setValue(2, 6, "Out of Stock:")
applyTableStyleForRange(sheet1, 3, 6, 6, 2);
sheet1.setArray(3, 6, [
["Category", "Product"]
]);
sheet1.setFormula(4, 6, '=FILTER(TableSheet1[Category]:TableSheet1[Product Name], TableSheet1[Units In Stock] = 0)');
//Filters
sheet1.setValue(13, 0, "Category:");
sheet1.setFormula(13, 1, "=A5");
var dv2 = GC.Spread.Sheets.DataValidation.createFormulaListValidator('=$A$5#');
sheet1.setDataValidator(13, 1, dv2);
sheet1.setValue(13, 3, "Category ID:");
sheet1.setFormula(13, 4, '=QUERY("categoryTable?CategoryName="&B14, "Id")');
sheet1.comments.add(13, 4, 'Query the category id.');
applyTableStyleForRange(sheet1, 15, 0, 14, 3);
sheet1.setArray(15, 0, [
["ProductName", "UnitPrice", "UnitsInStock"]
]);
sheet1.setFormula(16, 0, '=QUERY("productTable?CategoryId="&E14, A16:C16)');
sheet1.comments.add(16, 0, 'Use the QUERY function to get data from DataManager.');
spread.setActiveSheetIndex(0);
spread.resumePaint();
});
spread.resumePaint();
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/learn-spreadjs\//)[0] + 'server/api';
}
function applyTableStyleForRange(sheet, row, col, rowCount, colCount, options) {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.light2, options);
sheet.tables.remove(tableName, 2 /* keep style */ );
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta name="spreadjs culture" content="ko-kr" />
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Promise Polyfill for IE, https://www.npmjs.com/package/promise-polyfill -->
<script src="https://cdn.jsdelivr.net/npm/promise-polyfill@8/dist/polyfill.min.js"></script>
<script src="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets-resources-ko/dist/gc.spread.sheets.resources.ko.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div id="optionContainer" class="optionContainer">
</div>
</div>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}

사용자는 구조화된 참조를 사용하여 워크시트에서 표와 같은 테이블 시트를 참조할 수 있습니다.
테이블 시트 이름은 표 이름이고 열 캡션은 표 열입니다. 샘플 코드는 다음과 같습니다.
또한 A1/R1C1 참조 스타일을 지원하지만 읽는 것이 어렵습니다.
참조 스타일은 셀 수식, 차트, 조건부 서식에서 사용할 수 있습니다.
사용자는 QUERY 함수를 사용하여 DataManager 표에서 데이터를 가져올 수 있습니다.
QUERY 구문
반환 유형
예시
전체 표
QUERY("table1")
전체 열
QUERY("table1", "column1")
데이터
QUERY("table1#1", "column1")QUERY("customer/abc@gmail.com", "name")
특정 행
QUERY("table1#1")QUERY("customer/abc@gmail.com")
행 필터
사용자는 간단한 행 필터를 사용할 수 있습니다.
유형
예시
행 인덱스별
QUERY("table1#1")
행 기본 키별
QUERY("customer/abc@gmail.com")
키-값 필터별
QUERY("order?status=sucess")
여러 열
사용자는 배열을 사용하여 많은 열을 선택할 수 있습니다.
유형
예시
열 배열별
QUERY("order?status=shipping", {"order date", "address", "Cargo weight"})
1차원 참조별
QUERY("order?status=shipping", A1:D1)
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import '@mescius/spread-sheets-resources-ko';
GC.Spread.Common.CultureManager.culture("ko-kr");
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
hostStyle = {
width: '100%',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
let spread = $event.spread;
spread.suspendPaint();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
spread.options.allowDynamicArray = true;
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add product table
var productTable = dataManager.addTable("productTable", {
remote: {
read: {
url: baseApiUrl + "/Product"
}
}
});
//add category table
var categoryTable = dataManager.addTable("categoryTable", {
remote: {
read: {
url: baseApiUrl + "/Category"
}
}
});
//add relation ship
dataManager.addRelationship(productTable, "CategoryId", "category", categoryTable, "Id", "products");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader);
//bind a view to the table sheet
var myView = productTable.addView("myView", [
{ value: "Id", caption: "ID" },
{ value: "category.CategoryName", caption: "Category", width: 120 },
{ value: "ProductName", caption: "Product Name", width: 200 },
{ value: "UnitPrice", caption: "Unit Price", width: 120 },
{ value: "UnitsInStock", caption: "Units In Stock", width: 120 },
{ value: "UnitsOnOrder", caption: "Units On Order", width: 130 },
{ value: "=SUM([@UnitsInStock], [@UnitsOnOrder])", caption: "Total Amount", width: 130 },
{ value: "=[@UnitPrice] * SUM([@UnitsInStock], [@UnitsOnOrder])", caption: "Total Price", width: 120 }
]);
let _this = this;
myView.fetch().then(function () {
spread.suspendPaint();
sheet.setDataView(myView);
var sheet1 = spread.getSheet(0);
sheet1.setColumnWidth(0, 170);
sheet1.setColumnWidth(1, 95);
sheet1.setColumnWidth(2, 95);
sheet1.setColumnWidth(3, 120);
sheet1.setColumnWidth(4, 170);
sheet1.setColumnWidth(6, 110);
sheet1.setColumnWidth(7, 170);
sheet1.setValue(0, 0, "Product Count:")
sheet1.setFormula(0, 1, "=COUNTA(TableSheet1[ID])");
sheet1.setValue(0, 3, 'Total Price:')
sheet1.setFormula(0, 4, '=SUM(TableSheet1[Total Price])');
//Category Summary
_this.applyTableStyleForRange(sheet1, 3, 0, 9, 5);
sheet1.setValue(2, 0, "Category Summary:")
sheet1.setArray(3, 0, [
["Category", "Product No", "On Order Cost", "Highest Unit Price", "Highest Price Product"]
]);
sheet1.setFormula(4, 0, '=UNIQUE(TableSheet1[Category])');
sheet1.setFormula(4, 1, '=COUNTIF(TableSheet1[Category], A5#)');
sheet1.setFormula(4, 3, '=MAXIFS(TableSheet1[Unit Price], TableSheet1[Category], A5#)');
for (var i = 5; i <= 12; i++) {
sheet1.setFormula(i - 1, 2, '=SUMPRODUCT((TableSheet1[Category]=A' + i + ')*TableSheet1[Units On Order],TableSheet1[Unit Price])');
sheet1.setFormula(i - 1, 4, '=XLOOKUP(D' + i + ', IF(TableSheet1[Category] = A' + i + ', TableSheet1[Unit Price], -1), TableSheet1[Product Name])');
}
//Out of Stock
sheet1.setValue(2, 6, "Out of Stock:")
_this.applyTableStyleForRange(sheet1, 3, 6, 6, 2);
sheet1.setArray(3, 6, [
["Category", "Product"]
]);
sheet1.setFormula(4, 6, '=FILTER(TableSheet1[Category]:TableSheet1[Product Name], TableSheet1[Units In Stock] = 0)');
//Filters
sheet1.setValue(13, 0, "Category:");
sheet1.setFormula(13, 1, "=A5");
var dv2 = GC.Spread.Sheets.DataValidation.createFormulaListValidator('=$A$5#');
sheet1.setDataValidator(13, 1, dv2);
sheet1.setValue(13, 3, "Category ID:");
sheet1.setFormula(13, 4, '=QUERY("categoryTable?CategoryName="&B14, "Id")');
sheet1.comments.add(13, 4, 'Query the category id.');
_this.applyTableStyleForRange(sheet1, 15, 0, 14, 3);
sheet1.setArray(15, 0, [
["ProductName", "UnitPrice", "UnitsInStock"]
]);
sheet1.setFormula(16, 0, '=QUERY("productTable?CategoryId="&E14, A16:C16)');
sheet1.comments.add(16, 0, 'Use the QUERY function to get data from DataManager.');
spread.setActiveSheetIndex(0);
spread.resumePaint();
});
spread.resumePaint();
}
applyTableStyleForRange(sheet: GC.Spread.Sheets.Worksheet, row: number, col: number, rowCount: number, colCount: number, options?: any) {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.light2, options);
sheet.tables.remove(tableName, 2 /* keep style */ );
}
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/learn-spreadjs\//)[0] + 'server/api';
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/ko/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/ko/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/ko/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/ko/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-resources-ko': 'npm:@mescius/spread-sheets-resources-ko/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

사용자는 구조화된 참조를 사용하여 워크시트에서 표와 같은 테이블 시트를 참조할 수 있습니다.
테이블 시트 이름은 표 이름이고 열 캡션은 표 열입니다. 샘플 코드는 다음과 같습니다.
또한 A1/R1C1 참조 스타일을 지원하지만 읽는 것이 어렵습니다.
참조 스타일은 셀 수식, 차트, 조건부 서식에서 사용할 수 있습니다.
사용자는 QUERY 함수를 사용하여 DataManager 표에서 데이터를 가져올 수 있습니다.
QUERY 구문
반환 유형
예시
전체 표
QUERY("table1")
전체 열
QUERY("table1", "column1")
데이터
QUERY("table1#1", "column1")QUERY("customer/abc@gmail.com", "name")
특정 행
QUERY("table1#1")QUERY("customer/abc@gmail.com")
행 필터
사용자는 간단한 행 필터를 사용할 수 있습니다.
유형
예시
행 인덱스별
QUERY("table1#1")
행 기본 키별
QUERY("customer/abc@gmail.com")
키-값 필터별
QUERY("order?status=sucess")
여러 열
사용자는 배열을 사용하여 많은 열을 선택할 수 있습니다.
유형
예시
열 배열별
QUERY("order?status=shipping", {"order date", "address", "Cargo weight"})
1차원 참조별
QUERY("order?status=shipping", A1:D1)
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import '@mescius/spread-sheets-resources-ko';
GC.Spread.Common.CultureManager.culture("ko-kr");
import './styles.css';
export function AppFunc() {
const initSpread = (spread) => {
spread.suspendPaint();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
spread.options.allowDynamicArray = true;
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add product table
var productTable = dataManager.addTable("productTable", {
remote: {
read: {
url: baseApiUrl + "/Product"
}
}
});
//add category table
var categoryTable = dataManager.addTable("categoryTable", {
remote: {
read: {
url: baseApiUrl + "/Category"
}
}
});
//add relation ship
dataManager.addRelationship(productTable, "CategoryId", "category", categoryTable, "Id", "products");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader);
//bind a view to the table sheet
var myView = productTable.addView("myView", [
{ value: "Id", caption: "ID" },
{ value: "category.CategoryName", caption: "Category", width: 120 },
{ value: "ProductName", caption: "Product Name", width: 200 },
{ value: "UnitPrice", caption: "Unit Price", width: 120 },
{ value: "UnitsInStock", caption: "Units In Stock", width: 120 },
{ value: "UnitsOnOrder", caption: "Units On Order", width: 130 },
{ value: "=SUM([@UnitsInStock], [@UnitsOnOrder])", caption: "Total Amount", width: 130 },
{ value: "=[@UnitPrice] * SUM([@UnitsInStock], [@UnitsOnOrder])", caption: "Total Price", width: 120 }
]);
myView.fetch().then(function () {
spread.suspendPaint();
sheet.setDataView(myView);
var sheet1 = spread.getSheet(0);
sheet1.setColumnWidth(0, 170);
sheet1.setColumnWidth(1, 95);
sheet1.setColumnWidth(2, 95);
sheet1.setColumnWidth(3, 120);
sheet1.setColumnWidth(4, 170);
sheet1.setColumnWidth(6, 110);
sheet1.setColumnWidth(7, 170);
sheet1.setValue(0, 0, "Product Count:")
sheet1.setFormula(0, 1, "=COUNTA(TableSheet1[ID])");
sheet1.setValue(0, 3, 'Total Price:')
sheet1.setFormula(0, 4, '=SUM(TableSheet1[Total Price])');
//Category Summary
applyTableStyleForRange(sheet1, 3, 0, 9, 5);
sheet1.setValue(2, 0, "Category Summary:")
sheet1.setArray(3, 0, [
["Category", "Product No", "On Order Cost", "Highest Unit Price", "Highest Price Product"]
]);
sheet1.setFormula(4, 0, '=UNIQUE(TableSheet1[Category])');
sheet1.setFormula(4, 1, '=COUNTIF(TableSheet1[Category], A5#)');
sheet1.setFormula(4, 3, '=MAXIFS(TableSheet1[Unit Price], TableSheet1[Category], A5#)');
for (var i = 5; i <= 12; i++) {
sheet1.setFormula(i - 1, 2, '=SUMPRODUCT((TableSheet1[Category]=A' + i + ')*TableSheet1[Units On Order],TableSheet1[Unit Price])');
sheet1.setFormula(i - 1, 4, '=XLOOKUP(D' + i + ', IF(TableSheet1[Category] = A' + i + ', TableSheet1[Unit Price], -1), TableSheet1[Product Name])');
}
//Out of Stock
sheet1.setValue(2, 6, "Out of Stock:")
applyTableStyleForRange(sheet1, 3, 6, 6, 2);
sheet1.setArray(3, 6, [
["Category", "Product"]
]);
sheet1.setFormula(4, 6, '=FILTER(TableSheet1[Category]:TableSheet1[Product Name], TableSheet1[Units In Stock] = 0)');
//Filters
sheet1.setValue(13, 0, "Category:");
sheet1.setFormula(13, 1, "=A5");
var dv2 = GC.Spread.Sheets.DataValidation.createFormulaListValidator('=$A$5#');
sheet1.setDataValidator(13, 1, dv2);
sheet1.setValue(13, 3, "Category ID:");
sheet1.setFormula(13, 4, '=QUERY("categoryTable?CategoryName="&B14, "Id")');
sheet1.comments.add(13, 4, 'Query the category id.');
applyTableStyleForRange(sheet1, 15, 0, 14, 3);
sheet1.setArray(15, 0, [
["ProductName", "UnitPrice", "UnitsInStock"]
]);
sheet1.setFormula(16, 0, '=QUERY("productTable?CategoryId="&E14, A16:C16)');
sheet1.comments.add(16, 0, 'Use the QUERY function to get data from DataManager.');
spread.setActiveSheetIndex(0);
spread.resumePaint();
});
spread.resumePaint();
}
const applyTableStyleForRange = (sheet, row, col, rowCount, colCount, options) => {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.light2, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
</div>
);
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/learn-spreadjs\//)[0] + 'server/api';
}
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import '@mescius/spread-sheets-resources-ko';
GC.Spread.Common.CultureManager.culture("ko-kr");
import './styles.css';
const Component = React.Component;
export class App extends Component {
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
</div>
);
}
initSpread(spread) {
spread.suspendPaint();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
spread.options.allowDynamicArray = true;
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add product table
var productTable = dataManager.addTable("productTable", {
remote: {
read: {
url: baseApiUrl + "/Product"
}
}
});
//add category table
var categoryTable = dataManager.addTable("categoryTable", {
remote: {
read: {
url: baseApiUrl + "/Category"
}
}
});
//add relation ship
dataManager.addRelationship(productTable, "CategoryId", "category", categoryTable, "Id", "products");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader);
//bind a view to the table sheet
var myView = productTable.addView("myView", [
{ value: "Id", caption: "ID" },
{ value: "category.CategoryName", caption: "Category", width: 120 },
{ value: "ProductName", caption: "Product Name", width: 200 },
{ value: "UnitPrice", caption: "Unit Price", width: 120 },
{ value: "UnitsInStock", caption: "Units In Stock", width: 120 },
{ value: "UnitsOnOrder", caption: "Units On Order", width: 130 },
{ value: "=SUM([@UnitsInStock], [@UnitsOnOrder])", caption: "Total Amount", width: 130 },
{ value: "=[@UnitPrice] * SUM([@UnitsInStock], [@UnitsOnOrder])", caption: "Total Price", width: 120 }
]);
let _this = this;
myView.fetch().then(function () {
spread.suspendPaint();
sheet.setDataView(myView);
var sheet1 = spread.getSheet(0);
sheet1.setColumnWidth(0, 170);
sheet1.setColumnWidth(1, 95);
sheet1.setColumnWidth(2, 95);
sheet1.setColumnWidth(3, 120);
sheet1.setColumnWidth(4, 170);
sheet1.setColumnWidth(6, 110);
sheet1.setColumnWidth(7, 170);
sheet1.setValue(0, 0, "Product Count:")
sheet1.setFormula(0, 1, "=COUNTA(TableSheet1[ID])");
sheet1.setValue(0, 3, 'Total Price:')
sheet1.setFormula(0, 4, '=SUM(TableSheet1[Total Price])');
//Category Summary
_this.applyTableStyleForRange(sheet1, 3, 0, 9, 5);
sheet1.setValue(2, 0, "Category Summary:")
sheet1.setArray(3, 0, [
["Category", "Product No", "On Order Cost", "Highest Unit Price", "Highest Price Product"]
]);
sheet1.setFormula(4, 0, '=UNIQUE(TableSheet1[Category])');
sheet1.setFormula(4, 1, '=COUNTIF(TableSheet1[Category], A5#)');
sheet1.setFormula(4, 3, '=MAXIFS(TableSheet1[Unit Price], TableSheet1[Category], A5#)');
for (var i = 5; i <= 12; i++) {
sheet1.setFormula(i - 1, 2, '=SUMPRODUCT((TableSheet1[Category]=A' + i + ')*TableSheet1[Units On Order],TableSheet1[Unit Price])');
sheet1.setFormula(i - 1, 4, '=XLOOKUP(D' + i + ', IF(TableSheet1[Category] = A' + i + ', TableSheet1[Unit Price], -1), TableSheet1[Product Name])');
}
//Out of Stock
sheet1.setValue(2, 6, "Out of Stock:")
_this.applyTableStyleForRange(sheet1, 3, 6, 6, 2);
sheet1.setArray(3, 6, [
["Category", "Product"]
]);
sheet1.setFormula(4, 6, '=FILTER(TableSheet1[Category]:TableSheet1[Product Name], TableSheet1[Units In Stock] = 0)');
//Filters
sheet1.setValue(13, 0, "Category:");
sheet1.setFormula(13, 1, "=A5");
var dv2 = GC.Spread.Sheets.DataValidation.createFormulaListValidator('=$A$5#');
sheet1.setDataValidator(13, 1, dv2);
sheet1.setValue(13, 3, "Category ID:");
sheet1.setFormula(13, 4, '=QUERY("categoryTable?CategoryName="&B14, "Id")');
sheet1.comments.add(13, 4, 'Query the category id.');
_this.applyTableStyleForRange(sheet1, 15, 0, 14, 3);
sheet1.setArray(15, 0, [
["ProductName", "UnitPrice", "UnitsInStock"]
]);
sheet1.setFormula(16, 0, '=QUERY("productTable?CategoryId="&E14, A16:C16)');
sheet1.comments.add(16, 0, 'Use the QUERY function to get data from DataManager.');
spread.setActiveSheetIndex(0);
spread.resumePaint();
});
spread.resumePaint();
}
applyTableStyleForRange(sheet, row, col, rowCount, colCount, options) {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.light2, options);
sheet.tables.remove(tableName, 2 /* keep style */ );
}
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/learn-spreadjs\//)[0] + 'server/api';
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/ko/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/ko/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@mescius/spread-sheets-resources-ko': 'npm:@mescius/spread-sheets-resources-ko/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

사용자는 구조화된 참조를 사용하여 워크시트에서 표와 같은 테이블 시트를 참조할 수 있습니다.
테이블 시트 이름은 표 이름이고 열 캡션은 표 열입니다. 샘플 코드는 다음과 같습니다.
또한 A1/R1C1 참조 스타일을 지원하지만 읽는 것이 어렵습니다.
참조 스타일은 셀 수식, 차트, 조건부 서식에서 사용할 수 있습니다.
사용자는 QUERY 함수를 사용하여 DataManager 표에서 데이터를 가져올 수 있습니다.
QUERY 구문
반환 유형
예시
전체 표
QUERY("table1")
전체 열
QUERY("table1", "column1")
데이터
QUERY("table1#1", "column1")QUERY("customer/abc@gmail.com", "name")
특정 행
QUERY("table1#1")QUERY("customer/abc@gmail.com")
행 필터
사용자는 간단한 행 필터를 사용할 수 있습니다.
유형
예시
행 인덱스별
QUERY("table1#1")
행 기본 키별
QUERY("customer/abc@gmail.com")
키-값 필터별
QUERY("order?status=sucess")
여러 열
사용자는 배열을 사용하여 많은 열을 선택할 수 있습니다.
유형
예시
열 배열별
QUERY("order?status=shipping", {"order date", "address", "Cargo weight"})
1차원 참조별
QUERY("order?status=shipping", A1:D1)
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
</div>
</template>
<script>
import Vue from "vue";
import "@mescius/spread-sheets-vue";
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-tablesheet";
import '@mescius/spread-sheets-resources-ko';
GC.Spread.Common.CultureManager.culture("ko-kr");
import "./styles.css";
let App = Vue.extend({
name: "app",
methods: {
initSpread: function (spread) {
spread.suspendPaint();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
spread.options.allowDynamicArray = true;
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add product table
var productTable = dataManager.addTable("productTable", {
remote: {
read: {
url: baseApiUrl + "/Product"
}
}
});
//add category table
var categoryTable = dataManager.addTable("categoryTable", {
remote: {
read: {
url: baseApiUrl + "/Category"
}
}
});
//add relation ship
dataManager.addRelationship(productTable, "CategoryId", "category", categoryTable, "Id", "products");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader);
//bind a view to the table sheet
var myView = productTable.addView("myView", [
{ value: "Id", caption: "ID" },
{ value: "category.CategoryName", caption: "Category", width: 120 },
{ value: "ProductName", caption: "Product Name", width: 200 },
{ value: "UnitPrice", caption: "Unit Price", width: 120 },
{ value: "UnitsInStock", caption: "Units In Stock", width: 120 },
{ value: "UnitsOnOrder", caption: "Units On Order", width: 130 },
{ value: "=SUM([@UnitsInStock], [@UnitsOnOrder])", caption: "Total Amount", width: 130 },
{ value: "=[@UnitPrice] * SUM([@UnitsInStock], [@UnitsOnOrder])", caption: "Total Price", width: 120 }
]);
let _this = this;
myView.fetch().then(function () {
spread.suspendPaint();
sheet.setDataView(myView);
var sheet1 = spread.getSheet(0);
sheet1.setColumnWidth(0, 170);
sheet1.setColumnWidth(1, 95);
sheet1.setColumnWidth(2, 95);
sheet1.setColumnWidth(3, 120);
sheet1.setColumnWidth(4, 170);
sheet1.setColumnWidth(6, 110);
sheet1.setColumnWidth(7, 170);
sheet1.setValue(0, 0, "Product Count:")
sheet1.setFormula(0, 1, "=COUNTA(TableSheet1[ID])");
sheet1.setValue(0, 3, 'Total Price:')
sheet1.setFormula(0, 4, '=SUM(TableSheet1[Total Price])');
//Category Summary
_this.applyTableStyleForRange(sheet1, 3, 0, 9, 5);
sheet1.setValue(2, 0, "Category Summary:")
sheet1.setArray(3, 0, [
["Category", "Product No", "On Order Cost", "Highest Unit Price", "Highest Price Product"]
]);
sheet1.setFormula(4, 0, '=UNIQUE(TableSheet1[Category])');
sheet1.setFormula(4, 1, '=COUNTIF(TableSheet1[Category], A5#)');
sheet1.setFormula(4, 3, '=MAXIFS(TableSheet1[Unit Price], TableSheet1[Category], A5#)');
for (var i = 5; i <= 12; i++) {
sheet1.setFormula(i - 1, 2, '=SUMPRODUCT((TableSheet1[Category]=A' + i + ')*TableSheet1[Units On Order],TableSheet1[Unit Price])');
sheet1.setFormula(i - 1, 4, '=XLOOKUP(D' + i + ', IF(TableSheet1[Category] = A' + i + ', TableSheet1[Unit Price], -1), TableSheet1[Product Name])');
}
//Out of Stock
sheet1.setValue(2, 6, "Out of Stock:")
_this.applyTableStyleForRange(sheet1, 3, 6, 6, 2);
sheet1.setArray(3, 6, [
["Category", "Product"]
]);
sheet1.setFormula(4, 6, '=FILTER(TableSheet1[Category]:TableSheet1[Product Name], TableSheet1[Units In Stock] = 0)');
//Filters
sheet1.setValue(13, 0, "Category:");
sheet1.setFormula(13, 1, "=A5");
var dv2 = GC.Spread.Sheets.DataValidation.createFormulaListValidator('=$A$5#');
sheet1.setDataValidator(13, 1, dv2);
sheet1.setValue(13, 3, "Category ID:");
sheet1.setFormula(13, 4, '=QUERY("categoryTable?CategoryName="&B14, "Id")');
sheet1.comments.add(13, 4, 'Query the category id.');
_this.applyTableStyleForRange(sheet1, 15, 0, 14, 3);
sheet1.setArray(15, 0, [
["ProductName", "UnitPrice", "UnitsInStock"]
]);
sheet1.setFormula(16, 0, '=QUERY("productTable?CategoryId="&E14, A16:C16)');
sheet1.comments.add(16, 0, 'Use the QUERY function to get data from DataManager.');
spread.setActiveSheetIndex(0);
spread.resumePaint();
});
spread.resumePaint();
},
applyTableStyleForRange(sheet, row, col, rowCount, colCount, options) {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.light2, options);
sheet.tables.remove(tableName, 2 /* keep style */ );
}
},
});
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/learn-spreadjs\//)[0] + 'server/api';
}
new Vue({
render: (h) => h(App),
}).$mount("#app");
</script>
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/vue/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/ko/vue/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.vue');
System.import('$DEMOROOT$/ko/lib/vue/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: 'vue-loader' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-resources-ko': 'npm:@mescius/spread-sheets-resources-ko/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.min.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
}
}
});
})(this);